#include <Wire.h>
#include <Adafruit_MCP23017.h>

#define PORTA0 (uint8_t)0
#define PORTA1 (uint8_t)1
#define PORTA2 (uint8_t)2
#define PORTA3 (uint8_t)3
#define PORTA4 (uint8_t)4
#define PORTA5 (uint8_t)5
#define PORTA6 (uint8_t)6
#define PORTA7 (uint8_t)7
#define PORTB0 (uint8_t)8
#define PORTB1 (uint8_t)9
#define PORTB2 (uint8_t)10
#define PORTB3 (uint8_t)11
#define PORTB4 (uint8_t)12
#define PORTB5 (uint8_t)13
#define PORTB6 (uint8_t)14
#define PORTB7 (uint8_t)15

Adafruit_MCP23017 mcp1; // Create MCP 1

void setup() 
{  
  mcp1.begin((uint8_t)0x0);// relative Adresse zu 0x20
  mcp1.pinMode(PORTA0, INPUT);
  mcp1.pullUp(PORTA0,HIGH);
  mcp1.pinMode(PORTA1, INPUT);
  mcp1.pullUp(PORTA1,HIGH);
  mcp1.pinMode(PORTA2, INPUT);
  mcp1.pullUp(PORTA2,HIGH);
  mcp1.pinMode(PORTA3, INPUT);
  mcp1.pullUp(PORTA3,HIGH);
  mcp1.pinMode(PORTA4, INPUT);
  mcp1.pullUp(PORTA4,HIGH);
  mcp1.pinMode(PORTA6, OUTPUT);
  mcp1.pinMode(PORTA7, OUTPUT);
  mcp1.pinMode(PORTB0, OUTPUT);
  mcp1.pinMode(PORTB1, OUTPUT);
  mcp1.pinMode(PORTB2, OUTPUT);
  mcp1.pinMode(PORTB3, OUTPUT);
  mcp1.pinMode(PORTB4, OUTPUT);
  mcp1.pinMode(PORTB5, OUTPUT);
  mcp1.pinMode(PORTB6, OUTPUT);
  mcp1.pinMode(PORTB7, OUTPUT);
  RunningLight();
 }

void loop() 
{
  uint8_t i = 0;

  for(i = (uint8_t)0; i < (uint8_t)5; i++)
  {
    if (mcp1.digitalRead(i) == LOW)
    {
      if ( (uint8_t)0 == i)
        RunningLight();
      mcp1.digitalWrite(11 + i, HIGH);
    }
    else
    {
      mcp1.digitalWrite(11 + i, LOW);
    }
  }
}

void RunningLight(void)
{
  uint8_t i = (uint8_t)0;
  uint8_t j = (uint8_t)0;
  uint8_t level = HIGH;

  for(i = (uint8_t)6; i <= 15; i++)
  {
    for(j = 0; j < 2; j++)
    {
      mcp1.digitalWrite(i, level);
      delay(100);
      if (level == HIGH)
      {
        level = LOW;
      }
      else
      {
        level = HIGH;
      }
    }
  }
}

